freeslot("S_PLAY_BANDAGEFLIP", "S_PLAY_BANDAGEEAGLE1", "S_PLAY_BANDAGEEAGLE2",
"S_PLAY_BANDAGEEAGLE3", "SPR_BNLK", "S_BANDAGE_LOCKON", "sfx_bndaim", "S_PLAY_SHIT", "SPR2_SHIT")
states[S_PLAY_BANDAGEFLIP] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_FALL}
states[S_PLAY_BANDAGEEAGLE1] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 4, nil, 2, 2, S_PLAY_BANDAGEEAGLE2}
states[S_PLAY_BANDAGEEAGLE2] = {SPR_PLAY, SPR2_GLID, 4, nil, 0, 0, S_PLAY_BANDAGEEAGLE3}
states[S_PLAY_BANDAGEEAGLE3] = {SPR_PLAY, SPR2_GLID, TICRATE*2/3, nil, 0, 0, S_PLAY_FALL}
states[S_BANDAGE_LOCKON] = {SPR_BNLK, FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}
sfxinfo[sfx_bndaim].caption = "Whoosh"

//Reset time
local resetbandages = function(player)
	if player.boomspindash
		player.normalspeed = skins[player.realmo.skin].normalspeed
		player.height = skins[player.realmo.skin].height
	end
	if player.enerspeed != skins[player.realmo.skin].normalspeed
		player.enerspeed = skins[player.realmo.skin].normalspeed
		player.normalspeed = skins[player.realmo.skin].normalspeed
	end
	player.boomspindash = false
	player.enertarget = nil
	player.enerdist = nil
	player.enertime = 0
	player.enerleft = 2
	player.enerhoming = 0
	player.enercooldown = 0
	player.enerbeam = 0
end

//Followitem used for Legacy Bandages
freeslot("MT_BANDAGES_LEGACY")
mobjinfo[MT_BANDAGES_LEGACY] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}
addHook("MobjSpawn", function(mobj)
	mobj.shadowscale = FRACUNIT
end, MT_BANDAGES_LEGACY)
addHook("FollowMobj", function(player, mobj)
	if not (player.mo and player.mo.valid and mobj and mobj.valid) return true end
	if player.legacybandages
		mobj.skin = player.mo.skin
		mobj.state = player.mo.state
		mobj.frame = player.mo.frame
		mobj.sprite2 = player.mo.sprite2|FF_SPR2SUPER
		mobj.angle = player.drawangle
		mobj.color = player.mo.color
		mobj.colorized = player.mo.colorized
		mobj.scale = player.mo.scale
		mobj.radius = player.mo.radius
		mobj.height = player.mo.height
		mobj.flags2 = player.mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
		mobj.eflags = player.mo.eflags&MFE_VERTICALFLIP
		player.mo.flags2 = $|MF2_DONTDRAW
		mobj.flags2 = $&~MF2_LINKDRAW
	elseif mobj.state != S_INVISIBLE
		mobj.state = S_INVISIBLE
	end
	P_TeleportMove(mobj,player.mo.x,player.mo.y,player.mo.z)
	return true
end, MT_BANDAGES_LEGACY)

//Make it so the signpost shows the legacy sprite when you are legacy
function A_SignPlayer(mobj, var1, var2)
	super(mobj, var1, var2)
	if var1 == -1 and mobj.tracer and mobj.tracer.valid
	and mobj.tracer.tracer and mobj.tracer.tracer.valid 
	and mobj.target and mobj.target.valid and mobj.target.player
	and mobj.target.skin == "bandages" and mobj.target.player.legacybandages
		mobj.tracer.tracer.sprite2 = $|FF_SPR2SUPER
		mobj.tracer.tracer.tics = -1
	end
end

//Make the life icon show legacy when you are legacy
hud.add(function(v, player, cam)
	if player.realmo and player.realmo.valid and player.realmo.skin == "bandages"
	and player.legacybandages and hud.enabled("lives")
		v.drawScaled(16*FRACUNIT, 176*FRACUNIT, FRACUNIT/2,
		v.getSprite2Patch(player.realmo.skin, SPR2_XTRA, true),
		V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER,
		v.getColormap(nil, player.realmo.color))
	end
end)

//Enerbeam Helper
freeslot("MT_ENERBEAMHELPER", "S_ENERBEAMHELPER")
mobjinfo[MT_ENERBEAMHELPER] = {
	doomednum = -1,
	spawnstate = S_ENERBEAMHELPER,
	deathstate = S_INVISIBLE,
	xdeathstate = S_INVISIBLE,
	spawnhealth = 1000,
	damage = 0,
	speed = 128*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_MISSILE|MF_NOBLOCKMAP
}
states[S_ENERBEAMHELPER] = {SPR_NULL, 0, 6, nil, 0, 0, S_NULL}
addHook("MobjThinker", function(mobj)
	if mobj.state == S_INVISIBLE and not (mobj.target and mobj.target.valid
	and mobj.target.player and mobj.target.player.enertarget == mobj)
		mobj.state = S_NULL
	end
end, MT_ENERBEAMHELPER)
addHook("ShouldDamage", function(target, inflictor, source)
	if inflictor and inflictor.valid and inflictor.type == MT_ENERBEAMHELPER
		return false
	end
end)

//enerbeampoint badnikdeletus, and legacyisreal2401 commands
local enerbeampoint = true
local badnikdeletus = false
addHook("NetVars", function(network)
	enerbeampoint = network($)
	badnikdeletus = network($)
end)
COM_AddCommand("enerbeampoint", function(player, arg)
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			enerbeampoint = false
			CONS_Printf(player, "Enerbeam points will no longer spawn, and Bandages can now latch onto enemies.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			enerbeampoint = true
			CONS_Printf(player, "Enerbeam points will be present in enemy spawn points next level load.")
		elseif enerbeampoint
			CONS_Printf(player, "enerbeampoint [on/off] - When on, Enerbeam grapple points will spawn for Bandages players in each enemy spawn point. This also disables latching onto enemies and using the homing attack, which usually causes desynch. Currently on.")
		else
			CONS_Printf(player, "enerbeampoint [on/off] - When on, Enerbeam grapple points will spawn for Bandages players in each enemy spawn point. This also disables latching onto enemies and using the homing attack, which usually causes desynch. Currently off.")
		end
	elseif enerbeampoint
		CONS_Printf(player, "enerbeampoint [on/off] - When on, Enerbeam grapple points will spawn for Bandages players in each enemy spawn point. This also disables latching onto enemies and using the homing attack, which usually causes desynch. Currently on.")
	else
		CONS_Printf(player, "enerbeampoint [on/off] - When on, Enerbeam grapple points will spawn for Bandages players in each enemy spawn point. This also disables latching onto enemies and using the homing attack, which usually causes desynch. Currently off.")
	end
end, 1)
COM_AddCommand("badnikdeletus", function(player, arg)
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			badnikdeletus = false
			CONS_Printf(player, "Enemies will now spawn as normal.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			badnikdeletus = true
			CONS_Printf(player, "Enemies will no longer spawn.")
		elseif badnikdeletus
			CONS_Printf(player, "badnikdeletus [on/off] - When on, enemies won't load upon entering a level. Helps prevent desynch from enemies. Currently on.")
		elseif player.mo and player.mo.valid
			CONS_Printf(player, "badnikdeletus [on/off] - When on, enemies won't load upon entering a level. Helps prevent desynch from enemies. Currently off.")
		end
	elseif badnikdeletus
		CONS_Printf(player, "badnikdeletus [on/off] - When on, enemies won't load upon entering a level. Helps prevent desynch from enemies. Currently on.")
	else
		CONS_Printf(player, "badnikdeletus [on/off] - When on, enemies won't load upon entering a level. Helps prevent desynch from enemies. Currently off.")
	end
end, 1)
//legacyisreal2401 command
COM_AddCommand("legacyisreal2401", function(player, arg)
	if not (player.realmo and player.realmo.valid) return end
	if arg != nil
		if arg == "0" or arg == "default" or arg == "off"
			player.legacybandages = false
		elseif arg == "1" or arg == "on"
			player.legacybandages = true
		end
	elseif player.legacybandages
		player.legacybandages = false
	else
		player.legacybandages = true
	end
	resetbandages(player)
	if player.legacybandages
		player.mindash = 60*FRACUNIT
		player.maxdash = 100*FRACUNIT
		player.thrustfactor = 12
		player.accelstart = 102
		player.acceleration = 43
		player.charability = CA_AIRDRILL
		player.spinitem = MT_SPARK
		player.thokitem = MT_SPARK
		player.revitem = MT_THOK
		player.charflags = $&~SF_NOJUMPSPIN&~SF_NOJUMPDAMAGE|SF_NOSPINDASHDUST
	else
		player.mindash = skins[player.realmo.skin].mindash
		player.maxdash = skins[player.realmo.skin].maxdash
		player.thrustfactor = skins[player.realmo.skin].thrustfactor
		player.accelstart = skins[player.realmo.skin].accelstart
		player.acceleration = skins[player.realmo.skin].acceleration
		player.charability = skins[player.realmo.skin].ability
		player.spinitem = MT_THOK
		player.thokitem = MT_THOK
		player.revitem = MT_NULL
		player.charflags = skins[player.realmo.skin].flags
	end
end, 0)

//Enerbeam point object
freeslot("MT_ENERBEAMPOINT", "S_ENERBEAMPOINT")
mobjinfo[MT_ENERBEAMPOINT] = {
	doomednum = -1,
	spawnstate = S_ENERBEAMPOINT,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOGRAVITY|MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
states[S_ENERBEAMPOINT] = {SPR_SPHR, B, -1, nil, 0, 0, S_NULL}
//Don't draw them for non-Bandages
addHook("MobjThinker", function(mobj)
	if displayplayer and displayplayer.valid
	and displayplayer.realmo and displayplayer.realmo.valid
	and displayplayer.realmo.skin == "bandages"
	and not displayplayer.legacybandages
		if mobj.flags2&MF2_DONTDRAW then mobj.flags2 = $&~MF2_DONTDRAW end
	elseif not (mobj.flags2&MF2_DONTDRAW) then mobj.flags2 = $|MF2_DONTDRAW end
end, MT_ENERBEAMPOINT)
//Spawn the enerbeam points if we can
//Also deletes enemies for the badnikdeletus command
addHook("MapThingSpawn", function(mobj, mapthing)
	if netgame and (mobj.flags&MF_ENEMY or mobj.type == MT_TURRET)
		if enerbeampoint and mobj.type != MT_TURRET
			local point = P_SpawnMobjFromMobj(mobj,0,0,0,MT_ENERBEAMPOINT)
			if point and point.valid
				point.shadowscale = FRACUNIT
				point.color = SKINCOLOR_SKY
				point.colorized = true
			end
		end
		if badnikdeletus
			P_RemoveMobj(mobj)
			return true
		end
	end
end)

//I reuse code alot
local EnemyLookDeluxe = function(player, distancemulti, span)
	if not (player.mo and player.mo.valid) return end
	local maxdist = FixedMul(distancemulti, player.mo.scale)
	local thokmobj = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_THOK)
	thokmobj.radius = maxdist
	local closestmo = nil
	local closestdist = 0

	searchBlockmap("objects", function(refmobj, mo)
		//Prevent targeting Battle's target dummy since we can target players anyways
		if (pcall(function() local v = _G["MT_TARGETDUMMY"] end, "MT_TARGETDUMMY")
		and mo.type == _G["MT_TARGETDUMMY"]) then return end
		
		local trash = R_PointToAngle2(player.mo.x, player.mo.y, mo.x, mo.y)
		
		if (mo.flags & MF_NOCLIPTHING) or mo.health <= 0
		or mo == player.mo or mo.flags2 & MF2_FRET or not P_CheckSight(player.mo, mo)
		or ((twodlevel or player.mo.flags2 & MF2_TWOD) and abs(player.mo.y-mo.y) > player.mo.radius)
		or ((trash - player.mo.angle > span) or (trash - player.mo.angle < -1*span))
		return end

		if mo.player
			if mo.player.spectator
				return
			//elseif G_GametypeHasTeams() and mo.player.ctfteam == player.ctfteam
			//	return
			//elseif G_TagGametype() and (mo.player.pflags & PF_TAGIT) == (player.pflags & PF_TAGIT)
			//	return
			//elseif G_PlatformGametype() and not (CBW_Battle and CBW_Battle.BattleGametype())
			//	return
			end
		elseif mo.flags & MF_SPRING or mo.type == MT_ENERBEAMPOINT
			//nothing
		elseif netgame and (mo.flags&MF_ENEMY or mo.type == MT_EGGSHIELD)
		and enerbeampoint
			return
		elseif (!((mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) and (mo.flags & MF_SHOOTABLE))) == !(mo.flags2 & MF2_INVERTAIMABLE)) // allows if it has the flags desired XOR it has the invert aimable flag
			return // not a valid target
		end
		
		if mo.z+mo.height < player.mo.floorz and mo.z > player.mo.ceilingz
			return
		end
		
		local zdist = (player.mo.z + player.mo.height/2) - (mo.z + mo.height/2)
		local dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)
		if ((R_PointToAngle2(0, 0, dist, zdist) + span) > span*2) and ((R_PointToAngle2(0, 0, dist, -1*zdist) + span) > span*2)
			return // Don't home outside of desired angle!
		end
		
		if abs(zdist) > maxdist/2
			return
		end

		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist) or (closestmo and dist > closestdist)
			return // out of range
		end

		closestmo = mo
		closestdist = dist
	end, thokmobj)
	
	P_RemoveMobj(thokmobj)
	return closestmo, closestdist
end

//Spawns objects in a circle
local function bandagecircle(mobj, mobjtype, ns, vertical, vertangle)
	if mobjtype == MT_DUST and mobj.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
		mobjtype = MT_SMALLBUBBLE
	end
	local i = 0	while i < 8
		local fa = (i*(ANGLE_180/4))
		local mo = P_SpawnMobj(mobj.x, mobj.y, mobj.z+(mobj.height/2), mobjtype)
		if mo and mo.valid
			if mobjtype == MT_DUST
				if mobj.player and
				((mobj.player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
				or (mobj.player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA)
					mo.state = S_SPINDUST_FIRE1
				else
					mo.state = S_SPINDUST1
				end
			end
			if vertical
				mo.momz = FixedMul(sin(fa),ns)/2
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns)/2)
			else
				mo.momx = FixedMul(sin(fa),ns)/2
				mo.momy = FixedMul(cos(fa),ns)/2
			end
		end
		i = $+1
	end
end

//Enerbeam Homing Attack and Double Jump
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "bandages" and not player.legacybandages
		if player.enertime then return end
		if player.enertarget and player.enertarget.valid
		and not (netgame and enerbeampoint)
		and player.enertarget.type != MT_ENERBEAMHELPER
		and player.enertarget.type != MT_ENERBEAMPOINT
		and (player.enertarget.type != MT_PLAYER
		or (CBW_Battle and CBW_Battle.GetInteractionType(player.mo,player.enertarget)))
			if not P_IsObjectOnGround(player.mo) and not player.enertime
				player.mo.tracer = player.enertarget
				player.mo.target = player.enertarget
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_s3k40)
				if CBW_Battle
					player.enerhoming = 10
				else
					player.enerhoming = TICRATE*3/2
				end
				player.pflags = $&~PF_THOKKED&~PF_NOJUMPDAMAGE|PF_JUMPED
			end
		elseif (player.powers[pw_shield] & SH_NOSTACK) > 1
		and (player.powers[pw_shield] & SH_NOSTACK) != SH_PINK
		and player.cmd.buttons&BT_USE and not (player.pflags&PF_USEDOWN)
		and not (player.pflags&PF_SHIELDABILITY) and not (player.pflags&PF_THOKKED)
			//
		elseif player.charability == CA_DOUBLEJUMP and not (player.pflags&PF_THOKKED)
		or (player.charflags&SF_MULTIABILITY and (player.secondjump < player.actionspd >> FRACBITS))
		or (player.enertarget and player.enertarget.valid)
			player.pflags = $|PF_THOKKED&~PF_JUMPED
			P_DoJump(player, true)
			player.mo.state = S_PLAY_BANDAGEFLIP
			player.secondjump = $+1
			bandagecircle(player.mo, MT_DUST, 8 << FRACBITS, false, 0)
			if player.speed > 25*player.mo.scale
				P_InstaThrust(player.mo, R_PointToAngle2(0,0,player.mo.momx, player.mo.momy), 20*player.mo.scale)
			end
		end
		player.enertarget = nil
		player.enerdist = nil
		return true
	end
end)

//Start the Spindash/Enerbeam
addHook("SpinSpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "bandages" and not player.legacybandages
		//Disallows the rest of the code in certain circumstances
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.powers[pw_nocontrol]
		or player.exiting
		or player.pflags&PF_USEDOWN
		or ((player.powers[pw_shield] & SH_NOSTACK) > 1
		and (player.powers[pw_shield] & SH_NOSTACK) != SH_PINK and player.cmd.buttons&BT_JUMP
		and not (player.pflags&PF_SHIELDABILITY) and not (player.pflags&PF_THOKKED))
		or player.boomspindash
			if P_SuperReady(player)
				return
			else
				return true
			end
		end
		
		if P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_JUSTHITFLOOR
			player.boomspindash = true
			player.pflags = $|PF_STARTDASH&~PF_SPINNING
		elseif not (player.enertarget and player.enertarget.valid)
		and not player.enerhoming and not player.enercooldown
		and not (player.pflags&PF_USEDOWN)
		and not (player.isxmomentum and (player.mo.state == S_PLAY_TRICKUP or player.mo.state == S_PLAY_TRICKDOWN))
			local object, distance = EnemyLookDeluxe(player, RING_DIST*5/3, ANGLE_45)
			if object and object.valid
				player.enertarget = object
				player.enerleft = max($,1)
				player.enerbeam = 1
			elseif not player.enerleft
				return true
			else
				player.enertarget = P_SPMAngle(player.mo, MT_ENERBEAMHELPER, player.mo.angle+ANGLE_180, 0)
				if player.enertarget and player.enertarget.valid
					player.enertarget.momz = player.enertarget.info.speed/4*P_MobjFlip(player.mo)
					player.enertarget.momx = $*-1
					player.enertarget.momy = $*-1
					P_TeleportMove(player.enertarget, player.enertarget.x+(player.enertarget.momx/2),
					player.enertarget.y+(player.enertarget.momy/2), player.enertarget.z)
					player.enerleft = max($-1,0)
					player.enerbeam = 1
				else
					return true
				end
			end
			player.enercooldown = 22
			player.enertime = 7
			player.enermomx = player.mo.momx
			player.enermomy = player.mo.momy
			//player.pflags = $|PF_THOKKED
			S_StartSound(player.mo, sfx_beelec)
		end
		
		return true
	end
end)

//The infinite jump glitch from Rise of Lyric, now in SRB2!
//Uses a command for synch reasons
COM_AddCommand("secretcommand", function(player, arg)
	if arg == "nopeeking"
		if gametyperules&GTR_FRIENDLY
		and player.pflags&PF_THOKKED
		and player.mo and player.mo.valid
		and not P_IsObjectOnGround(player.mo)
		and player.mo.skin == "bandages"
		and not player.legacybandages
			player.pflags = $&~PF_THOKKED
		end
	else
		CONS_Printf(player, "Bouncepad!")
	end
end)

//Force the spindash animation when using the spindash
//Also do SFX override for Legacy Bandages
addHook("PostThinkFrame", do
	if menuactive and leveltime > TICRATE
	and gametyperules&GTR_FRIENDLY
	and consoleplayer and consoleplayer.valid
	and consoleplayer.pflags&PF_THOKKED
	and consoleplayer.mo and consoleplayer.mo.valid
	and not P_IsObjectOnGround(consoleplayer.mo)
	and consoleplayer.mo.skin == "bandages"
	and not consoleplayer.legacybandages
		COM_BufInsertText(consoleplayer, "secretcommand nopeeking")
	end
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "bandages"
			if player.legacybandages
				//Spin
				if S_SoundPlaying(player.mo,sfx_spin)
					S_StopSoundByID(player.mo,sfx_spin)
					S_StartSound(player.mo,sfx_s3k46)
				end
				//Spindash
				if S_SoundPlaying(player.mo,sfx_spndsh)
					S_StopSoundByID(player.mo,sfx_spndsh)
					S_StartSound(player.mo,sfx_s3k83)
				end
			elseif player.boomspindash and player.mo.state != S_PLAY_SPINDASH
			and not (player.mo.eflags & MFE_SPRUNG)
			and not (P_PlayerInPain(player)
			or (player.pflags & PF_SLIDING)
			or player.powers[pw_carry] != CR_NONE
			or player.spectator
			or player.playerstate != PST_LIVE
			or not player.mo.health
			or player.panim == PA_PAIN
			or player.powers[pw_super] == 1
			or player.iseggrobo
			or player.powers[pw_nocontrol]
			or player.exiting)
				player.mo.state = S_PLAY_SPINDASH
			end
		end
	end
end)

//No using shields if you're not holding jump at the same time
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "bandages"
	and not player.legacybandages and not ((player.powers[pw_shield] & SH_NOSTACK) > 1
	and (player.powers[pw_shield] & SH_NOSTACK) != SH_PINK and player.cmd.buttons&BT_JUMP
	and not (player.pflags&PF_SHIELDABILITY) and not (player.pflags&PF_THOKKED))
		return true
	end
end)

//Allow attacking while spindashing or while being latched onto an enemy
//Also start the Sonic Eagle if we've jumped and aren't spinning
addHook("PlayerCanDamage", function(player, mobj)
	if not (player.mo and player.mo.valid
	and player.mo.skin == "bandages" and not player.legacybandages) return end
	if player.boomspindash or (player.enertarget and player.enertarget.valid)
	or player.enercooldown
		return true
	elseif (player.pflags&PF_JUMPED and player.pflags&PF_NOJUMPDAMAGE)
	and not (player.pflags&PF_SPINNING)
		if player.mo.state != S_PLAY_BANDAGEEAGLE1 and player.mo.state != S_PLAY_BANDAGEEAGLE2
		//and player.mo.state != S_PLAY_BANDAGEEAGLE3
		and (mobj.type != MT_METALSONIC_BATTLE
		or abs(P_AproxDistance(mobj.x - player.mo.x, mobj.y - player.mo.y)) <= (player.mo.radius+mobj.radius)*2)
		and (mobj.z - mobj.scale <= player.mo.z + player.mo.height + player.mo.momz
		and mobj.z + mobj.height + mobj.scale >= player.mo.z + player.mo.momz)
			player.eagleangle = R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y)
			player.drawangle = player.eagleangle
			player.mo.state = S_PLAY_BANDAGEEAGLE1
			player.mo.frame = (player.mo.frame&~FF_FRAMEMASK)|2
			S_StartSound(player.mo, sfx_bndaim)
		end
		return true
	end
end)

//Wall Breaker Function
local wallbreak = function(mobj, sectorthing)
	local nerds = false
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Wall Breaker
addHook("MobjLineCollide", function(mobj, line)
	if not (line and line.valid and mobj and mobj.valid
	and mobj.player and mobj.skin == "bandages" and not mobj.player.legacybandages
	and not P_IsObjectOnGround(mobj) and mobj.player.pflags&PF_JUMPED
	and mobj.player.pflags&PF_NOJUMPDAMAGE) return end
	local killone = false
	local killtwo = false
	if line.frontsector and line.frontsector.valid then killone = wallbreak(mobj, line.frontsector) end
	if line.backsector and line.backsector.valid then killtwo = wallbreak(mobj, line.backsector) end
	if killone or killtwo
		mobj.player.eagleangle = R_PointToAngle2(mobj.x, mobj.y, P_ClosestPointOnLine(mobj.x, mobj.y, line))
		mobj.player.drawangle = mobj.player.eagleangle
		mobj.state = S_PLAY_BANDAGEEAGLE1
		mobj.frame = (mobj.frame&~FF_FRAMEMASK)|2
		S_StartSound(mobj, sfx_bndaim)
		if mobj.player.speed > 25*mobj.scale
			P_InstaThrust(mobj, R_PointToAngle2(0,0,mobj.momx, mobj.momy), 20*mobj.scale)
		end
		P_BounceMove(mobj)
	end
end, MT_PLAYER)

//Cancel the Enerbeam homing when you hit something
addHook("MobjDamage", function(target, inflictor, source)
	if inflictor and inflictor.valid and inflictor.skin == "bandages"
	and inflictor.player and inflictor.player.enerhoming
		if not P_IsObjectOnGround(inflictor)
		and not (inflictor.eflags & MFE_SPRUNG)
			if inflictor.tracer and inflictor.tracer.valid
			and inflictor.tracer.flags2&MF2_FRET
				inflictor.momx = $/2
				inflictor.momy = $/2
				inflictor.momz = $/2
			else
				P_InstaThrust(inflictor,0,0)
				inflictor.player.pflags = $&~PF_JUMPED
				P_DoJump(inflictor.player, false)
				inflictor.state = S_PLAY_JUMP
			end
		end
		inflictor.player.enerhoming = 0
	end
end)

addHook("PlayerSpawn", function(player)
	resetbandages(player)
end)

//Main Thinker	
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "bandages"
	
		//Disallows the rest of the code in certain circumstances
		if player.legacybandages
		or P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.powers[pw_nocontrol]
		or player.exiting
			resetbandages(player)
			if not player.mo.health and player.legacybandages
				player.mo.sprite2 = $|FF_SPR2SUPER
			end
		return end
		
		//Do a flip!!
		if (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING)
		and player.mo.momz*P_MobjFlip(player.mo) <= P_GetMobjGravity(player.mo)*-8*P_MobjFlip(player.mo)
			player.mo.state = S_PLAY_BANDAGEFLIP
		end
		
		//Keep your angle while doing the Sonic Eagle
		if player.mo.state == S_PLAY_BANDAGEEAGLE1
		or player.mo.state == S_PLAY_BANDAGEEAGLE2
		or player.mo.state == S_PLAY_BANDAGEEAGLE3
			if player.eagleangle == nil
				player.eagleangle = player.drawangle
			end
			player.drawangle = player.eagleangle
			if player.mo.state != S_PLAY_BANDAGEEAGLE3
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.tracer = player.mo
				ghost.flags2 = $|MF2_LINKDRAW
				ghost.info.dispoffset = -1
			end
		end
		
		//Go into jump mode after hitting a spring
		if player.mo.eflags & MFE_SPRUNG and not P_IsObjectOnGround(player.mo)
		and not (player.pflags&PF_JUMPED)
		and not (player.isxmomentum)
			player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_THOKKED&~PF_SHIELDABILITY
		end
		
		//Doing a homing attack from the enerbeam
		if player.enerhoming
			if player.mo.tracer and player.mo.tracer.valid
			and not (player.mo.eflags & MFE_SPRUNG)
			and not P_IsObjectOnGround(player.mo)
			and player.mo.tracer.health
			and not (player.mo.tracer.flags2&MF2_FRET)
			and not (player.mo.tracer.player and P_PlayerInPain(player.mo.tracer.player))
				local zdist = player.mo.tracer.z - player.mo.z
				if P_MobjFlip(player.mo) == -1 then zdist = (player.mo.tracer.z + player.mo.tracer.height) - (player.mo.z + player.mo.height) end
				local dist = P_AproxDistance(P_AproxDistance(player.mo.tracer.x - player.mo.x, player.mo.tracer.y - player.mo.y), zdist)
				if dist < 1 then dist = 1 end
				local ns = FixedDiv(FixedMul(player.actionspd*2, player.mo.scale), 3*FRACUNIT/2)
				player.mo.momx = FixedMul(FixedDiv(player.mo.tracer.x - player.mo.x, dist), ns)
				player.mo.momy = FixedMul(FixedDiv(player.mo.tracer.y - player.mo.y, dist), ns)
				player.mo.momz = FixedMul(FixedDiv(zdist, dist), ns)
				player.enerhoming = $-1
			else
				if player.mo.tracer and not player.mo.tracer.valid
					player.mo.tracer = nil
				end
				if not P_IsObjectOnGround(player.mo)
				and not (player.mo.eflags & MFE_SPRUNG)
					if player.mo.tracer and player.mo.tracer.valid
					and player.mo.tracer.flags2&MF2_FRET
						player.mo.momx = $/2
						player.mo.momy = $/2
						player.mo.momz = $/2
					else
						P_InstaThrust(player.mo,0,0)
						player.pflags = $&~PF_JUMPED
						P_DoJump(player, false)
						player.mo.state = S_PLAY_JUMP
					end
				end
				player.enerhoming = 0
			end
		end
		
		//Allow normal control when jumping from a spin or spinning in the air
		if player.pflags&PF_JUMPED and player.pflags&PF_SPINNING
			player.pflags = $&~PF_SPINNING
		end
		if not P_IsObjectOnGround(player.mo) and player.pflags&PF_SPINNING
			player.pflags = $&~PF_SPINNING|PF_JUMPED&~PF_NOJUMPDAMAGE
		end
		
		//Enerbeam Tether
		if player.enertarget and player.enertarget.valid
			if not P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_ROLL
				player.pflags = $&~PF_NOJUMPDAMAGE|PF_JUMPED
			end
			
			if player.enerbeam == nil
				player.enerbeam = 2
			else
				player.enerbeam = $+1
			end
			player.enerspeed = max(player.speed, skins[player.mo.skin].normalspeed+1)
			
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.colorized = true
			ghost.color = SKINCOLOR_SUPERSKY1
			
			local zdist = (player.mo.z + player.mo.momz + player.mo.height/2) - (player.enertarget.z + player.enertarget.momz + player.enertarget.height/2)
			local dist = P_AproxDistance(player.mo.x-player.enertarget.x, player.mo.y-player.enertarget.y)
			
			//Cancel the beam
			if not player.enertarget.health or player.enertarget.flags2 & MF2_FRET
			or (not (player.cmd.buttons&BT_USE) and not player.enertime)
			or (player.enerdist != nil and abs(dist) > abs(player.enerdist*64))
				player.enertarget = nil
				player.enerdist = nil
				player.enertime = 0
				player.pflags = $&~PF_THOKKED
				if player.enerbeam <= 11
					player.mo.momz = $/max((13-player.enerbeam),1)
				end
				if (player.mo.momz > 20*player.mo.scale and not (player.mo.eflags&MFE_VERTICALFLIP))
				or (player.mo.momz < -20*player.mo.scale and player.mo.eflags&MFE_VERTICALFLIP)
					P_SetObjectMomZ(player.mo, 20*FRACUNIT, false)
				end
				
			//Normal stuff
			else
			
			//player.pflags = $|PF_THOKKED
			
			//Render the beam
			local xoffset = P_ReturnThrustX(nil, player.drawangle, 10*player.enertarget.scale)+player.enertarget.x
			local yoffset = P_ReturnThrustY(nil, player.drawangle, 10*player.enertarget.scale)+player.enertarget.y

			// Now draw the line to the object from the tracer
			local numLineMobjs = min(max(R_PointToDist2(player.mo.x, player.mo.y, xoffset, yoffset)/(player.mo.scale*48), 16), 64)
	
			// Get distance for each step
			local distX = (xoffset - player.mo.x) / numLineMobjs
			local distY = (yoffset - player.mo.y) / numLineMobjs
			local distZ = ((player.enertarget.z + (player.enertarget.height/2)*4/7) - player.mo.z) / numLineMobjs
			if (player.enertarget.eflags & MFE_VERTICALFLIP) then distZ = (((player.enertarget.z + player.enertarget.height) - player.enertarget.height*4/7) - player.mo.z-player.mo.height) / numLineMobjs end
			
			if player.enertime and player.enertarget.type != MT_ENERBEAMHELPER
				numLineMobjs = $/player.enertime
			end
			
			local i = 0
			while (i <= numLineMobjs)
				local part = P_SpawnMobj(player.mo.x + (distX * i), player.mo.y + (distY * i), (player.mo.z+(player.mo.height/2)) + (distZ * i),  MT_CYBRAKDEMON_TARGET_DOT)
				part.sprite = SPR_ZAPS
				part.frame = 10-(leveltime%2)
				part.color = SKINCOLOR_SKY
				part.colorized = true
				part.scale = player.mo.scale/3
				part.fuse = 2
				//P_TeleportMove(part, part.x+FixedMul(P_RandomFixed()*20, player.mo.scale),
				//part.y+FixedMul(P_RandomFixed()*20, player.mo.scale),
				//part.z+FixedMul(P_RandomFixed()*20, player.mo.scale))
				i = $+1
			end
			
			//Timer before you actually attach
			if player.enertime
				player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.enertarget.x, player.enertarget.y)
				player.enertime = $-1
				player.mo.momz = 0
				player.mo.momx = 0
				player.mo.momy = 0
				//Connect!
				if not player.enertime
					player.enerdist = P_AproxDistance(dist, zdist)/16
					bandagecircle(player.enertarget, MT_SUPERSPARK, 16 << FRACBITS, false, 0)
					S_StartSound(player.mo, sfx_cdfm52)
					//Player Floor Distance
					local floor = P_FloorzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height)
					local foffloor
					if (player.mo.eflags&MFE_VERTICALFLIP)
						if player.mo.ceilingz == P_FloorzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height)
							floor = player.mo.floorz
						else
							floor = player.mo.ceilingz
						end
						if player.mo.ceilingrover and player.mo.ceilingrover.valid
							if player.mo.ceilingrover.b_slope and player.mo.ceilingrover.b_slope.valid
								foffloor = P_GetZAt(player.mo.ceilingrover.b_slope, player.mo.x, player.mo.y)
							else
								foffloor = player.mo.ceilingrover.bottomheight
							end
							if foffloor < floor then floor = foffloor end
						end
					elseif player.mo.floorrover and player.mo.floorrover.valid
						if player.mo.floorrover.t_slope and player.mo.floorrover.t_slope.valid
							foffloor = P_GetZAt(player.mo.floorrover.t_slope, player.mo.x, player.mo.y)
						else
							foffloor = player.mo.floorrover.topheight
						end
						if foffloor > floor then floor = foffloor end
					end
					local floordist = abs((player.mo.z + player.mo.height/2) - floor)
					//Enemy Floor Distance
					local floor = P_FloorzAtPos(player.enertarget.x, player.enertarget.y, player.enertarget.z, player.enertarget.height)
					local foffloor
					if (player.mo.eflags&MFE_VERTICALFLIP)
						if player.enertarget.ceilingz == P_FloorzAtPos(player.enertarget.x, player.enertarget.y, player.enertarget.z, player.enertarget.height)
							floor = player.enertarget.floorz
						else
							floor = player.enertarget.ceilingz
						end
						if player.enertarget.ceilingrover and player.enertarget.ceilingrover.valid
							if player.enertarget.ceilingrover.b_slope and player.enertarget.ceilingrover.b_slope.valid
								foffloor = P_GetZAt(player.enertarget.ceilingrover.b_slope, player.enertarget.x, player.enertarget.y)
							else
								foffloor = player.enertarget.ceilingrover.bottomheight
							end
							if foffloor < floor then floor = foffloor end
						end
					elseif player.enertarget.floorrover and player.enertarget.floorrover.valid
						if player.enertarget.floorrover.t_slope and player.enertarget.floorrover.t_slope.valid
							foffloor = P_GetZAt(player.enertarget.floorrover.t_slope, player.enertarget.x, player.enertarget.y)
						else
							foffloor = player.enertarget.floorrover.topheight
						end
						if foffloor > floor then floor = foffloor end
					end
					local floordist2 = abs((player.enertarget.z + player.enertarget.height/2) - floor)
					//Starting the Enerbeam makes you go up or down
					local ns = FRACUNIT/2
					if player.mo.eflags & MFE_UNDERWATER then ns = $*2 end
					if floordist2 <= player.mo.height*3 or player.enertarget.type == MT_EGGMOBILE4
						player.mo.momz = FixedDiv(400*FRACUNIT, 25*ns)*P_MobjFlip(player.mo)
					else
						player.mo.momz = -1*min(min(FixedDiv(floordist, 16*ns),FixedDiv(floordist2, 16*ns)), FixedDiv(400*FRACUNIT, 16*ns))*P_MobjFlip(player.mo)
					end
					player.mo.momx = player.enermomx
					player.mo.momy = player.enermomy
					//P_InstaThrust(player.mo, R_PointToAngle2(player.mo.x, player.mo.y, player.enertarget.x, player.enertarget.y), player.speed)
				end
			else
				//Pull yourself if you're too far
				if (P_AproxDistance(dist, zdist) >= player.enerdist)
					local ns = FixedMul(6*FRACUNIT, player.mo.scale)
					if player.mo.eflags & MFE_UNDERWATER then ns = $/2 end
						player.mo.momx = $+FixedMul(FixedDiv(player.enertarget.x - player.mo.x, 400*FRACUNIT), ns)
						player.mo.momy = $+FixedMul(FixedDiv(player.enertarget.y - player.mo.y, 400*FRACUNIT), ns)
						player.mo.momz = $-FixedMul(FixedDiv(zdist, 400*FRACUNIT), ns*3/2)
					end
				end
			end
		else
			//Modify variables for the enerbeam
			if player.enertarget and not player.enertarget.valid
				player.enertarget = nil
			end
			if player.enertime
				player.enertime = 0
			end
			if player.enerbeam and P_IsObjectOnGround(player.mo)
				player.enerbeam = 0
			end
			if player.enerleft < 2 and P_IsObjectOnGround(player.mo)
				player.enerleft = 2
			end
			if player.enercooldown
				if P_IsObjectOnGround(player.mo)
					player.enercooldown = 0
				else
					player.enercooldown = $-1
				end
			end
			//Temporary Speedup
			if player.enerspeed > skins[player.mo.skin].normalspeed
				player.enerspeed = max(min($-(FRACUNIT/4),player.speed*3/2), skins[player.mo.skin].normalspeed)
				player.normalspeed = player.enerspeed
			end
			//Lockon
			if not P_IsObjectOnGround(player.mo) and player.pflags&PF_JUMPED
			and not player.enercooldown
				local lockon = EnemyLookDeluxe(player, RING_DIST*5/3, ANGLE_45)
				if lockon and lockon.valid then P_SpawnLockOn(player, lockon, S_BANDAGE_LOCKON) end
			end
			//Jump Spin effect
			if not (player.pflags&PF_NOJUMPDAMAGE) and player.pflags&PF_JUMPED
			and not P_IsObjectOnGround(player.mo)
				if player.enerbeam and player.enerleft
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.colorized = true
					ghost.color = SKINCOLOR_SUPERSKY1
				elseif player.spinitem != -1
					P_SpawnSpinMobj(player, player.spinitem)
				end
			end
		end
		
		//Spindash
		//Again uses code from SRB2 Sonic
		//This code sure makes it way around huh?
		if player.boomspindash
			if not P_IsObjectOnGround(player.mo)
				player.dashspeed = 0
				player.pflags = $&~PF_STARTDASH
				if not (player.pflags&PF_JUMPED)
					player.pflags = $|PF_SPINNING
					player.mo.state = S_PLAY_ROLL
				end
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.height = skins[player.mo.skin].height
				player.boomspindash = false
			elseif player.cmd.buttons & BT_USE
				player.normalspeed = skins[player.mo.skin].normalspeed/12
				player.height = skins[player.mo.skin].spinheight
				local minspeed = skins[player.mo.skin].mindash
				local maxspeed = skins[player.mo.skin].maxdash
				player.pflags = $|PF_STARTDASH&~PF_SPINNING&~PF_APPLYAUTOBRAKE
				player.skidtime = 0
				if player.mo.state != S_PLAY_SPINDASH
					player.mo.state = S_PLAY_SPINDASH
				end
				local chargecalculation = (4*(player.dashspeed - (minspeed)))/((maxspeed) - (minspeed))
				player.dashspeed = min(max($+(FRACUNIT*4), minspeed), maxspeed)
				local soundcalculation = (4*(player.dashspeed - (minspeed)))/((maxspeed) - (minspeed))
				if not player.spectator and soundcalculation != chargecalculation
					S_StartSound(player.mo, sfx_spndsh)
				end
			
				local i = 0 while i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
					local particle
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SMALLBUBBLE)
					else
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
							particle.state = S_SPINDUST_FIRE1
						end
					end
				
					particle.target = player.mo
					particle.destscale = (2*player.mo.scale)/3
					P_SetScale(particle, particle.destscale)
					if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
						particle.z = player.mo.z + player.mo.height - particle.height
					end
					local prandom = {}
					prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
					prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
					prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
					P_SetObjectMomZ(particle, player.dashspeed/50 + prandom[0], false)
					P_InstaThrust(particle,
							player.mo.angle + (prandom[1]*ANG1),
							-FixedMul(player.dashspeed/12 + FRACUNIT + prandom[2], player.mo.scale))
					P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
				
					i = $+1
				end
			else
				P_InstaThrust(player.mo, player.mo.angle, FixedMul(player.dashspeed, player.mo.scale))
				player.dashspeed = 0
				S_StartSound(player.mo, sfx_zoom)
				player.pflags = $|PF_SPINNING&~PF_STARTDASH
				player.mo.state = S_PLAY_ROLL
				player.boomspindash = false
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.height = skins[player.mo.skin].height
			end
		end
	end
end)